#include <qthing.h>
#include "util.h"

#include <sstream>

#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "lwip/sockets.h"

unsigned long IRAM_ATTR millis() {
    return xTaskGetTickCount() * portTICK_PERIOD_MS;
}

std::string to_string(float value, int precision) {
    std::stringstream stream;
    stream.precision(precision);
    stream << value;
    return stream.str();
}

std::string to_string(uint32_t value) {
    std::stringstream stream;
    stream << value;
    return stream.str();
}

std::string to_string(struct sockaddr_in6 sourceAddr) {
    char addr_str[128];

    if (sourceAddr.sin6_family == PF_INET) {
        inet_ntoa_r(((struct sockaddr_in *)&sourceAddr)->sin_addr.s_addr, addr_str, sizeof(addr_str) - 1);
    } else if (sourceAddr.sin6_family == PF_INET6) {
        inet6_ntoa_r(sourceAddr.sin6_addr, addr_str, sizeof(addr_str) - 1);
    }

    return(std::string(addr_str));
}
